#! /bin/sh
#
# test-fs.sh - filesystem i/o test using $arg[0] as dir.
#
#  Copyright 2004, 2005 Sony Corp.
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; version 2 of the License.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#

__mkfnames128()
{
	f=$1
	i=0;
	l="";
	while [ $i -lt 128 ]; do
		n=`expr $i % 10`
		l=$n$l
		echo $f$l
		i=`expr $i + 1`
	done
}

mkfnames()
{
	__mkfnames128 fA
#	__mkfnames128 fB
#	__mkfnames128 fC
#	__mkfnames128 fD
}

mkdirnames()
{
	d="D_"
	i=0;
	l="";
	while [ $i -lt 2 ]; do
		n=`expr $i % 10`
		l=$n$l
		echo $d$l
		i=`expr $i + 1`
	done
}

do_test()
{
	(
	max=$1
	cur=$2
	echo == do_test $1 $2
	echo == MKDIR: ` mkdirnames`
	mkdirnames | xargs mkdir
	mkdirnames | while read d; do
		(cd $d
		echo -n  "-:$d"
		for sz in 4 512 1024 ; do
			echo -n "."
			mkfnames | xargs -i dd if=/dev/zero \
				of=\{\} bs=1024 count=$sz 2> /dev/null
			mkfnames | xargs -i rm \{\} 
		done
		echo
		cur=`expr $cur + 1`
		if [ $cur -le $max ]; then
			do_test $max  $cur
		fi
		)
		rmdir $d
	done
	)
}

TESTDIR=$1
TESTDIR=${TESTDIR:=/var/tmp/test}
rm -fr $TESTDIR
mkdir -p $TESTDIR 
cd $TESTDIR  || (echo "test directory '$TESTDIR' missing."; exit 1)
echo "Doing fs test with $TESTDIR."
do_test 2 1
